"use strict";

this.name        = "station_ads"; 
this.author      = "spara";
this.description = "Pooling ad service";

this.$vertAdsN = 73;
this.$horzAdsN = 379;
this.$commiesVertAdsN = 5;
this.$commiesHorzAdsN = 12;

this.startUp = function() {
	//Pools are divided to two parts to prevent the same ad to be seen in a quick succession. Pools are split into two parts and a primary part is randomly selected. When the active part is emptied, then the secondary part is used. When that is emptied too, pool is initialized and we draw from the primary part again.
	this._initVertPool();
	this.$vertPrimary = Math.round(Math.random());
	
	this._initHorzPool();
	this.$horzPrimary = Math.round(Math.random());
	
}

//init the pool and divide it into two parts.
this._initVertPool = function() {
	this.$vertPool = [new Array(), new Array()];
	var half = Math.round(this.$vertAdsN / 2);
	for (var i = 1; i < half; i++) {
		this.$vertPool[0].push("station_ads_vert_" + i + ".png");
	};
	for (var i = half; i <= this.$vertAdsN; i++) {
		this.$vertPool[1].push("station_ads_vert_" + i + ".png");
	};
}

this._initHorzPool = function() {
	this.$horzPool = [new Array(), new Array()];
	var half = Math.round(this.$horzAdsN / 2);
	for (var i = 1; i < half; i++) {
		this.$horzPool[0].push("station_ads_horz_" + i + ".png");
	};
	for (var i = half; i <= this.$horzAdsN; i++) {
		this.$horzPool[1].push("station_ads_horz_" + i + ".png");
	};
}

//public function that returns a random vertical ad filename from the pool
this._getVerticalAd = function() {
	//is the active part empty?
	if (this.$vertPool[this.$vertPrimary].length === 0) {
		//switch the active part
		this.$vertPrimary = (this.$vertPrimary + 1) % 2;
		//is the active part still empty
		if (this.$vertPool[this.$vertPrimary].length === 0) {
			//init pool
			this._initVertPool();
		};
	};
	//select an ad randomly from the active part
	var adNum = Math.floor(Math.random() * this.$vertPool[this.$vertPrimary].length);
	//return and remove the selected ad from the pool
	return this.$vertPool[this.$vertPrimary].splice(adNum, 1)[0];
}

//public function that returns a random horizontal ad filename from the pool
this._getHorizontalAd = function() {
	if (this.$horzPool[this.$horzPrimary].length === 0) {
		this.$horzPrimary = (this.$horzPrimary + 1) % 2;
		if (this.$horzPool[this.$horzPrimary].length === 0) {
			this._initHorzPool();
		};
	};
	var adNum = Math.floor(Math.random() * this.$horzPool[this.$horzPrimary].length);
	return this.$horzPool[this.$horzPrimary].splice(adNum, 1)[0];
}
